const Siesta    = require('siesta-lite/siesta-all.js')

const project   = new Siesta.Project.Browser();

project.configure({
    title       : 'React Google Fonts Space test suite'
});

project.plan(
    {
        // Tests in this group, exercises model - the data layer of the app
        group       : 'Model',

        items       : [
            './TRANSPILED/src/tests/model/mapper.t.js',
        ]
    },
    {
        // Tests in this group, exercises individual components
        group       : 'Individual components tests',

        items       : [
            './TRANSPILED/src/tests/components/text-box.t.js',
            './TRANSPILED/src/tests/components/color-picker.t.js'
        ]
    },
    {
        // Tests in this group, access application as a "black box"
        // they open the `index.html` page and then executes as a
        // script on that page
        group       : 'Black box tests',

        pageUrl     : 'index.html',

        items       : [
            './TRANSPILED/src/tests/blackbox-app/sanity.t.js',
            './TRANSPILED/src/tests/blackbox-app/compare.t.js'
        ]
    }
);

project.start();