export default {
  root: {
    name: '/',
    displayName: 'Home'
  },
  routes: [
    {
      name: 'dashboard',
      displayName: 'menu.dashboard'
    },
    {
      name: 'statistics',
      displayName: 'menu.statistics',
      disabled: true,
      children: [
        {
          name: 'charts',
          displayName: 'menu.charts',
        },
        {
          name: 'progress-bars',
          displayName: 'menu.progressBars'
        },
      ]
    },
    {
      name: 'forms',
      displayName: 'menu.forms',
      disabled: true,
      children: [
        {
          name: 'form-elements',
          displayName: 'menu.formElements'
        },
        {
          name: 'form-wizards',
          displayName: 'menu.formWizards'
        },
        {
          name: 'medium-editor',
          displayName: 'menu.mediumEditor'
        }
      ]
    },
    {
      name: 'tables',
      displayName: 'menu.tables'
    },
    {
      name: 'ui',
      displayName: 'menu.uiElements',
      disabled: true,
      children: [
        {
          name: 'typography',
          displayName: 'menu.typography'
        },
        {
          name: 'buttons',
          displayName: 'menu.buttons'
        },
        {
          name: 'collapse',
          displayName: 'menu.collapse'
        },
        {
          name: 'color-pickers',
          displayName: 'menu.colorPickers'
        },
        {
          path: 'timelines',
          displayName: 'menu.timelines'
        },
        {
          path: 'dropdowns',
          displayName: 'menu.dropdowns'
        },
        {
          path: 'notifications',
          displayName: 'menu.notifications'
        },
        {
          name: 'icon-sets',
          displayName: 'menu.icons',
          children: [
            {
              displayName: 'concrete',
              name: 'icon-set',
            },
          ]
        },
        {
          name: 'spinners',
          displayName: 'menu.spinners',
        },
        {
          name: 'grid',
          displayName: 'menu.grid',
        },
        {
          name: 'modals',
          displayName: 'menu.modals'
        },
        {
          name: 'file-upload',
          displayName: 'menu.fileUpload'
        },
        {
          name: 'tags',
          displayName: 'menu.tags'
        },
        {
          name: 'cards',
          displayName: 'menu.cards'
        },
        {
          name: 'tree-view',
          displayName: 'menu.treeView'
        }
      ]
    },
    {
      name: 'extra',
      displayName: 'menu.extra'
    },
    {
      name: 'maps',
      displayName: 'menu.maps',
      disabled: true,
      children: [
        {
          name: 'google-maps',
          displayName: 'Google Maps'
        },
        {
          name: 'yandex-maps',
          displayName: 'Yandex Maps'
        },
        {
          name: 'leaflet-maps',
          displayName: 'Leaflet Maps',
        },
        {
          name: 'bubble-maps',
          displayName: 'Bubble Maps'
        },
        {
          name: 'line-maps',
          displayName: 'Line Maps'
        }
      ]
    },
    {
      name: 'pages',
      displayName: 'menu.pages',
      disabled: true,
      children: [
        {
          name: '404-pages',
          displayName: '404 Pages'
        }
      ]
    }
  ]
}
