/*

Siesta 5.6.0
Copyright(c) 2009-2022 Bryntum AB
https://bryntum.com/contact
https://bryntum.com/products/siesta/license

*/
Ext.define('Siesta.Project.Browser.UI.AboutWindow', {
    extend      : 'Ext.Window',

    id          : 'aboutwindow',
    bodyPadding : 20,
    modal       : true,
    width       : 500,
    height      : 380,
    closeAction : 'destroy',
    bodyStyle   : 'background: #fff',
    autoScroll  : true,

    initComponent : function() {

        this.title = Siesta.Resource('Siesta.Project.Browser.UI.AboutWindow', 'titleText').replace('{VERSION}', Siesta.meta.VERSION || '1.0.0');
        this.html = Siesta.Resource('Siesta.Project.Browser.UI.AboutWindow', 'bodyText');

        this.buttons = {
            padding : '10 13',
            style   : 'background: transparent',

            items   : [
                {
                    hidden  : Siesta.Project.Browser.isStandardPackage(),
                    text    : Siesta.Resource('Siesta.Project.Browser.UI.AboutWindow', 'upgradeText'),
                    handler : function () {
                        window.open('https://bryntum.com/store/siesta');
                    }
                },
                {
                    text    : Siesta.Resource('Siesta.Project.Browser.UI.AboutWindow', 'closeText'),
                    handler : function () {
                        this.up('window').close();
                    }
                }
            ]
        };

        this.callParent(arguments);
    }
});

