Ext.data.JsonP.browserstack_integration({"guide":"<p><p><img src=\"guides/browserstack_integration/images/browserstack.png\" alt=\"\" width=\"2156\" height=\"632\"></p></p>\n<div class='toc'>\n<p><strong>Contents</strong></p>\n<ol>\n<li><a href='#!/guide/browserstack_integration-section-authentication'>Authentication</a></li>\n<li><a href='#!/guide/browserstack_integration-section-quick-testing'>Quick testing</a></li>\n<li><a href='#!/guide/browserstack_integration-section-parallelization'>Parallelization</a></li>\n<li><a href='#!/guide/browserstack_integration-section-under-the-hood'>Under the hood</a></li>\n<li><a href='#!/guide/browserstack_integration-section-shared-tunnel'>Shared tunnel</a></li>\n<li><a href='#!/guide/browserstack_integration-section-conclusion'>Conclusion</a></li>\n<li><a href='#!/guide/browserstack_integration-section-see-also%3A'>See also:</a></li>\n<li><a href='#!/guide/browserstack_integration-section-buy-this-product'>Buy this product</a></li>\n<li><a href='#!/guide/browserstack_integration-section-support'>Support</a></li>\n<li><a href='#!/guide/browserstack_integration-section-see-also'>See also</a></li>\n<li><a href='#!/guide/browserstack_integration-section-copyright-and-license'>COPYRIGHT AND LICENSE</a></li>\n</ol>\n</div>\n\n<h1 id='browserstack_integration-section-integration-with-browserstack-cloud-testing-infrastructure-'>Integration with BrowserStack cloud-testing infrastructure </h1>\n\n<p>Most of the web projects supports all major browsers. When aiming for the full certainty, about the quality of the product in every supported browser,\na logical step is to run the test suite in all those browsers. Counting Chrome, Firefox, Safari, Edge - thats at least 4x\nof the single test suite launch, so for the single-machine setup, the workload can quickly become extremely intense.</p>\n\n<p>One way to solve this bottleneck is to maintain a farm of virtual machines with various OS/browser combinations.\nThis can be tricky and will consume lots of your time and resources. Another, more elegant way is to use services\nproviding the same infrastructure in the cloud. Thanks to services such as <a href=\"http://www.browserstack.com/\">BrowserStack</a> it is now very simple.</p>\n\n<h2 id='browserstack_integration-section-authentication'>Authentication</h2>\n\n<p>When registering in BrowserStack, you will receive a user name and an access key. You can find these in your BrowserStack account\nunder \"Account -> Automate\" section. Later in this guide we will refer to these as \"BrowserStack username\" and \"BrowserStack access key\"</p>\n\n<h2 id='browserstack_integration-section-quick-testing'>Quick testing</h2>\n\n<p>All you need to launch your test suite in the cloud is to sign up for the BrowserStack trial and run the following command:</p>\n\n<pre><code>__SIESTA_DIR__/bin/webdriver http://localhost/my/siesta/project/wrapper.html --browserstack BS_USERNAME,BS_KEY \n--cap browser=firefox --cap os=windows --cap os_version=XP\n</code></pre>\n\n<p>That's all, the only difference from a normal Siesta automated launch is the <code>--browserstack</code> option, which is a shortcut performing\na few additional actions. We'll examine what happens under the hood later in this guide.</p>\n\n<p>Note how we have specified the desired OS/browser combination using the <code>--cap</code> switch (it specifies remote webdriver capability).\nFor a full list of supported capabilities please refer to <a href=\"http://www.browserstack.com/automate/capabilities\">http://www.browserstack.com/automate/capabilities</a></p>\n\n<h2 id='browserstack_integration-section-parallelization'>Parallelization</h2>\n\n<p>When using cloud-based infrastructure, each test page is running inside of the own VM, which guarantees the exclusive focus owning\nand allows us to run several test pages in parallel. Naturally, that speed ups the test execution, by the number of parallel sessions\nwe can run.</p>\n\n<p>This can be done using the <code>--max-workers</code> option, that specifies the maximum number of parallel sessions.</p>\n\n<h2 id='browserstack_integration-section-under-the-hood'>Under the hood</h2>\n\n<p>Let's examine what happens under the hood when we use the  <code>--browserstack</code> shortcut option. In fact, we don't have to use this shortcut\noption and can perform all the steps listed below manually.</p>\n\n<p>1) The first thing that happens is that Siesta establishes a local tunnel from your machine to the BrowserStack server, using the BrowserStack binaries.\nYou can do this step manually by using the batch file in the Siesta package:</p>\n\n<pre><code> __SIESTA_DIR__/bin/browserstacklocal --key BS_KEY\n</code></pre>\n\n<p>When launched successfully, you should see the following text:</p>\n\n<pre><code>Verifying parameters\n\nStarting local testing\nYou can now access your local server(s) in our remote browser:\nhttp://local:80\n\nPress Ctrl-C to exit\n</code></pre>\n\n<p>2) The \"--host\" option is set to point to the BrowserStack server, based on your username and access key:</p>\n\n<pre><code>--host=\"http://BS_USERNAME:BS_KEY@hub.browserstack.com/wd/hub\"\n</code></pre>\n\n<p>3) The browserstack specific capability \"browserstack.local\" is set to \"true\"</p>\n\n<p>To sum up, instead of using the <code>--browserstack</code> shortcut option, we could:</p>\n\n<ul>\n<li><p>launch the tunnel manually:</p>\n\n<pre><code>  __SIESTA_DIR__/bin/browserstacklocal --key BS_KEY\n</code></pre></li>\n<li><p>specify the command as:</p>\n\n<pre><code>  __SIESTA_DIR__/bin/webdriver http://localhost/my/siesta/project/wrapper.html \n      --host=\"http://BS_USERNAME:BS_KEY@hub.browserstack.com/wd/hub\" \n      --cap browser=firefox --cap os=windows --cap os_version=XP \n      --cap browserstack.local=true\n</code></pre></li>\n</ul>\n\n\n<p>For convenience, instead of setting the <code>--host</code> option manually, one can specify <code>--browserstack-user</code> and <code>--browserstack-key</code> options.</p>\n\n<pre><code>    __SIESTA_DIR__/bin/webdriver http://localhost/myproject/tests/project.html \n        --browserstack-user=BS_USERNAME --browserstack-key=BS_KEY\n        --cap browser=firefox --cap os=windows --cap os_version=XP \n        --cap browserstack.local=true\n</code></pre>\n\n<h2 id='browserstack_integration-section-shared-tunnel'>Shared tunnel</h2>\n\n<p>To share the tunnel to BrowserStack between the tests launches (saves the tunnel up/down time, convenient during development), use the\n<code>--browserstack_</code> option, which does the same things as <code>--browserstack</code> but uses existing tunnel.</p>\n\n<p>Then you'll need to launch the tunnel manually:</p>\n\n<pre><code>    __SIESTA_DIR__/bin/browserstacklocal --key BS_KEY\n</code></pre>\n\n<h2 id='browserstack_integration-section-conclusion'>Conclusion</h2>\n\n<p>As you can see, thanks to the excellent <a href=\"http://www.browserstack.com\">BrowserStack</a> infrastructure, launching your tests in the cloud is as easy as specifying\none extra argument on the command line. The benefits of cloud testing are obvious - no need to waste time and resources setting up and maintaining your own VM farm,\nand additionally you can run your test suite in various browsers in parallel.</p>\n\n<h2 id='browserstack_integration-section-see-also%3A'>See also:</h2>\n\n<p><a href=\"http://www.browserstack.com/local-testing\">http://www.browserstack.com/local-testing</a></p>\n\n<h2 id='browserstack_integration-section-buy-this-product'>Buy this product</h2>\n\n<p>Visit our store: <a href=\"https://bryntum.com/store/siesta\">https://bryntum.com/store/siesta</a></p>\n\n<h2 id='browserstack_integration-section-support'>Support</h2>\n\n<p>Ask a question in our community forum: <a href=\"https://www.bryntum.com/forum/viewforum.php?f=20\">https://www.bryntum.com/forum/viewforum.php?f=20</a></p>\n\n<p>Subscribers can post expedited questions in Premium Forum: <a href=\"https://www.bryntum.com/forum/viewforum.php?f=21\">https://www.bryntum.com/forum/viewforum.php?f=21</a></p>\n\n<p>Please report any bugs through the web interface at <a href=\"https://www.assembla.com/spaces/bryntum/support/tickets\">https://www.assembla.com/spaces/bryntum/support/tickets</a></p>\n\n<h2 id='browserstack_integration-section-see-also'>See also</h2>\n\n<p>Siesta web-page: <a href=\"https://bryntum.com/products/siesta\">https://bryntum.com/products/siesta</a></p>\n\n<p>Other Bryntum products: <a href=\"https://bryntum.com/products\">https://bryntum.com/products</a></p>\n\n<h2 id='browserstack_integration-section-copyright-and-license'>COPYRIGHT AND LICENSE</h2>\n\n<p>Copyright (c) 2009-2022, Bryntum AB &amp; Nickolay Platonov</p>\n\n<p>All rights reserved.</p>\n","title":"BrowserStack integration"});